Loading...
Searching...
No Matches
openshot::LensFlare Class Reference

`#include <effects/LensFlare.h>`

Inheritance diagram for openshot::LensFlare:

## Public Member Functions

std::shared_ptr< openshot::Frame > | GetFrame (int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number) override
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Json () const override
| Generate JSON string of this object.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
| LensFlare ()
| LensFlare (const Keyframe &xPos, const Keyframe &yPos, const Keyframe &intensity, const Keyframe &scale, const Keyframe &spreadVal, const Keyframe &bladeCount, const Keyframe &shapeType, const Color &tint=Color("#ffffff"))
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
| ~LensFlare () override
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects).
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout).
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL).
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds).
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video).
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video).
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers).
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers).
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any).
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds).
void | Position (float value)
| Set position on timeline (in seconds).
float | Start () const
| Get start position (in seconds) of clip (trim start of video).
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video).
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | brightness
Color | color
Keyframe | size
Keyframe | spread
Keyframe | x
Keyframe | y
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties).
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips).

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties).
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any).
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip).
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip).
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any).

## Detailed Description

Definition at line 24 of file LensFlare.h.

## Constructor & Destructor Documentation

## LensFlare() [1/2]

LensFlare::LensFlare | ( |  | ) |

Definition at line 47 of file LensFlare.cpp.

## ~LensFlare()

LensFlare::~LensFlare | ( |  | ) |

override default

## LensFlare() [2/2]

LensFlare::LensFlare | ( | const Keyframe & | xPos,
|  | const Keyframe & | yPos,
|  | const Keyframe & | intensity,
|  | const Keyframe & | scale,
|  | const Keyframe & | spreadVal,
|  | const Keyframe & | bladeCount,
|  | const Keyframe & | shapeType,
|  | const Color & | tint = Color("#ffffff") )

Definition at line 55 of file LensFlare.cpp.

## Member Function Documentation

## GetFrame() [1/2]

std::shared_ptr< openshot::Frame > LensFlare::GetFrame | ( | int64_t | frame_number | ) |

override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 361 of file LensFlare.cpp.

Referenced by GetFrame().

## GetFrame() [2/2]

std::shared_ptr< openshot::Frame > LensFlare::GetFrame | ( | std::shared_ptr< openshot::Frame > | frame,
|  | int64_t | frame_number )

override virtual

This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.

The frame object is passed into this method and used as a starting point / background (pixels). All Clip keyframes and effects are resolved into pixels.

Returns
  The modified openshot::Frame object

Parameters

  frame | This is ignored on Clip, due to caching optimizations. This frame instance is clobbered with the source frame.
  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 218 of file LensFlare.cpp.

## Json()

std::string LensFlare::Json | ( |  | ) | const

override virtual

Generate JSON string of this object.

Reimplemented from openshot::EffectBase.

Definition at line 367 of file LensFlare.cpp.

## JsonValue()

Json::Value LensFlare::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 373 of file LensFlare.cpp.

Referenced by Json().

## PropertiesJSON()

std::string LensFlare::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 406 of file LensFlare.cpp.

## SetJson()

void LensFlare::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 387 of file LensFlare.cpp.

## SetJsonValue()

void LensFlare::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 394 of file LensFlare.cpp.

Referenced by SetJson().

## Member Data Documentation

## brightness

Keyframe openshot::LensFlare::brightness

Definition at line 32 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

## color

Color openshot::LensFlare::color

Definition at line 35 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

## size

Keyframe openshot::LensFlare::size

Definition at line 33 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

## spread

Keyframe openshot::LensFlare::spread

Definition at line 34 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

## x

Keyframe openshot::LensFlare::x

Definition at line 30 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

## y

Keyframe openshot::LensFlare::y

Definition at line 31 of file LensFlare.h.

Referenced by GetFrame(), JsonValue(), LensFlare(), LensFlare(), PropertiesJSON(), and SetJsonValue().

The documentation for this class was generated from the following files:

- effects/LensFlare.h
- effects/LensFlare.cpp